﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Common;

namespace HeuristicLab.Hive.Contracts.ResponseObjects {
  /// <summary>
  /// Response Heartbeat class
  /// Return value to hearbeats sent by the client
  /// </summary>
  [StorableClass]
  [DataContract]
  [Serializable]
  public class ResponseHeartBeat : Response {
    [Storable]
    [DataMember]
    public List<MessageContainer> ActionRequest { get; set; }

    public ResponseHeartBeat() {
      this.ActionRequest = new List<MessageContainer>();
    }
    [StorableConstructor]
    protected ResponseHeartBeat(bool deserializing) : base(deserializing) { }
    protected ResponseHeartBeat(ResponseHeartBeat original, Cloner cloner)
      : base(original, cloner) {
      this.ActionRequest = (original.ActionRequest.Select(x => cloner.Clone(x))).ToList();
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new ResponseHeartBeat(this, cloner);
    }
  }
}
